#ifndef WEBVIEW_DIALOG_H
#define WEBVIEW_DIALOG_H
#ifndef SYNCTHINGTRAY_NO_WEBVIEW

#include "./webviewprovider.h"

#include "../application/settings.h"

#include <QMainWindow>

QT_FORWARD_DECLARE_CLASS(WEB_VIEW_PROVIDER)

namespace Settings {
struct ConnectionSettings;
}

namespace QtGui {

class WebViewDialog : public QMainWindow
{
    Q_OBJECT
public:
    WebViewDialog(QWidget *parent = nullptr);
    ~WebViewDialog();

public slots:
    void applySettings(const Settings::ConnectionSettings &connectionSettings);
    const Settings::ConnectionSettings &settings() const;

protected:
    void closeEvent(QCloseEvent *event);

private:
    WEB_VIEW_PROVIDER *m_view;
    Settings::ConnectionSettings m_settings;
};

inline const Settings::ConnectionSettings &WebViewDialog::settings() const
{
    return m_settings;
}

}

#endif // SYNCTHINGTRAY_NO_WEBVIEW
#endif // WEBVIEW_DIALOG_H
